#include "burnint.h"
// After Burner hardware - sprites

unsigned char *AftSprSrc=NULL; // Original sprite table

static INLINE int DrawSprite(unsigned char *ps)
{
  int nPal;

  bss.nTop   =((ps[ 1]<<8)|ps[ 0])&0x1ff; bss.nTop-=0x100;
  bss.nHeight=((ps[11]<<8)|ps[10])&0x1ff; bss.nHeight++;

  bss.nLeft=((ps[5]<<8)|ps[4])&0x1ff; bss.nLeft-=0xbc;
  bss.nWidth=(ps[5]&0xfe)<<2;

  nPal=ps[0x0c]<<4;
  bss.pPal=BsysPal+nPal;

  if (ps[5]&0x80) { bss.nWidth=0x400-bss.nWidth; }
  bss.nClipWidth=bss.nWidth;

  // Find the bitmap in the rom data
  bss.nBase=((ps[1]&0x0e)<<17) | (ps[3]<<10) | (ps[2]<<2);

  // Find the zoom values
  {
    int nZoomX,nZoomY;
    nZoomX=((ps[7]<<8)|ps[6])&0xfff;
    nZoomY=((ps[9]<<8)|ps[8])&0xfff;
    if (nZoomY==0) nZoomY=nZoomX;
    bss.nIncX=nZoomX;
    bss.nIncY=nZoomY;
  }

  bss.bFlipX=0;
  if ((ps[9]&0x40)==0) { bss.nBase+=4-(bss.nWidth>>1); bss.bFlipX=1; }
  bss.bDrawToLeft=((ps[9]&0x20)==0);
  bss.bDrawToTop= ((ps[9]&0x80)==0);
  if (ps[5]&0x80) bss.nIncY=-bss.nIncY; // Flip Y (into sprite above)

  bss.nTrans=0x0001; //normal transparent mask
  BsysSprDraw(); // Draw sprite
  return 0;
}

int AftSprDraw()
{
  int i=0; unsigned char *ps=NULL;

  ps=AftSprSrc;
  for (i=0; i<0x200; ps+=0x10,i++)
  {
    if (ps[1]&0x80) break; // end of list
    if (ps[1]&0x40) continue; // skip sprite
    DrawSprite(ps);
  }

  return 0;
}
