// Calc functions

static INLINE void CalcMult0(unsigned short *pm)
{
  int x,f,g,z;

  // Do the function of 0000
  // calculate f*g -> z   [0]*[2] -> [4].long
  x=pm[0]; if (x&0x8000) x-=0x10000;  f=x;
  x=pm[1]; if (x&0x8000) x-=0x10000;  g=x;
  z=f*g; // do operation

  x=z;
  pm[2]=(unsigned short)(x>>16);
  pm[3]=(unsigned short)(x&0xffff);
}

static INLINE void CalcDiv4(unsigned short *pm)
{
  int x,f,g;
  // Do the function of 4000
  // calculate f/g  Reg4[0].long/Reg4[4] -> Reg4[0x08]
  // calculate f%g  Reg4[0].long%Reg4[4] -> Reg4[0x0a]

  x=pm[0]; x<<=16; x|=pm[1]; f=x;
  x=pm[2]; if (x&0x8000) x-=0x10000;  g=x;

  // do operation
  if (g!=0) x=f/g; else x=0x7fff;
  pm[4]=(unsigned short)(x&0xffff);
  if (g!=0) x=f%g; else x=0;
  pm[5]=(unsigned short)(x&0xffff);
}

static INLINE void CalcDis4(unsigned short *pm)
{
  // Do the function of 4000 when 400C is hit (used a lot by TB to find height when scaling)
  int x,f,g;
  x=pm[0]; x<<=16; x|=pm[1]; f=x;
  x=pm[6]; if (x&0x8000) x-=0x10000;  g=x;

  // do operation
  if (g!=0) x=f/g; else x=0x7fffffff;
  pm[4]=(unsigned short)(x>>16);
  pm[5]=(unsigned short)(x&0xffff);
}

static INLINE void CalcDo8(unsigned short *pm)
{
  int x,f,g,h,z;
  // Do the function of 8000

  x=pm[0]; if (x&0x8000) x-=0x10000;  f=x;
  x=pm[1]; if (x&0x8000) x-=0x10000;  g=x;
  x=pm[2]; if (x&0x8000) x-=0x10000;  h=x;

  // this function is unknown - only used on helicopters? (0E8) and level 5 (2E8) ??
  // also used to attract the plane to the refueller before level 3
  z=0;
  if (f>g) { if (h<0) z=-1; if (h>0) z=+1; } // Used mainly in After Burner II
  else     { if (h<f) z=-1; if (h>g) z=+1; } // Used mainly in Thunder Blade

  x=z;
  pm[3]=(unsigned short)(x&0xffff);
}

