#include "burnint.h"
// System 16 - Palette

unsigned char *BsysPalSrc=NULL; // Pointer to input palette

int BsysPalInit()
{
  return 0;
}

int BsysPalExit()
{
  return 0;
}

static INLINE unsigned int CalcCol(unsigned char *ps,int i)
{
  unsigned int a; int r,g,b;
  a=*((unsigned short *)ps);
  //0000 BBBB GGGG RRRR
  // To truecolor:
  r=(a&0x000f)<<4; // rrrr 0000
  g=(a&0x00f0)   ; // gggg 0000
  b=(a&0x0f00)>>4; // bbbb 0000

  if (a&0x8000) g|=0x04;
  if (a&0x4000) b|=0x08;
  if (a&0x2000) g|=0x08;
  if (a&0x1000) r|=0x08;
  return BurnHighCol(r,g,b,i);
}

// Update BsysHigh with the current palette in BsysSrc
int BsysPalUpdate()
{
  unsigned int i; unsigned char *ps; unsigned int *ph;
  for (i=0,ps=BsysPalSrc,ph=BsysPal; i<nBsysPalLen; i++,ps+=2,ph++)
  {
    *ph=CalcCol(ps,i);
  }
  return 0;
}

// Write a word to BsysSrc
void BsysPalWriteByte(unsigned int a,unsigned char d)
{
  a^=1;
  a&=(nBsysPalLen<<1)-1; // Clip to palette length
  BsysPalSrc[a]=d; // write byte
}

// Write a word to BsysSrc
void BsysPalWriteWord(unsigned int a,unsigned short d)
{
  a&=(nBsysPalLen<<1)-2; // Clip to palette length
  *((unsigned short *)(BsysPalSrc+a))=d; // write word
}
