// draw sprites
#include "burnint.h"

unsigned char *BsysSprData=NULL; // Sprite bitmap data
int nBsysSprDataLen=0; // Length of above

struct BsysSprite bss; // Sprite to draw

int BsysSprDraw()
{
  int y,nBmapY;
  int nScrWidth,nStartPix,nPixLen,nStartBmapX,nStartBmapY;
  if (bss.nIncX<=0) return 1;
  if (bss.nIncY==0) return 1;

  nScrWidth=(bss.nClipWidth<<9)/bss.nIncX; // Work out how wide the sprite will be on the screen
  if (bss.bFlipX) { bss.nBase+=bss.nWidth>>1; bss.nIncX=-bss.nIncX; } // reverse the scan direction
  if (bss.bDrawToLeft)
  {
    // Modify so we can draw it left to right
    if (bss.bFlipX) bss.nBase-=bss.nWidth>>1;
    else            bss.nBase+=bss.nWidth>>1;
    bss.nLeft-=nScrWidth-1;
    bss.nIncX=-bss.nIncX;
  }
  // ------- Sprite is now a simple left to right one -------------

  if (bss.bDrawToTop)
  {
    int nDataHeight;
    nDataHeight=(bss.nHeight*bss.nIncY)>>9; // Work out how high the sprite is in memory
    if (nDataHeight>0) nDataHeight--; else nDataHeight++;
    // Modify so we can draw it top to bottom
    bss.nTop-=bss.nHeight;
    bss.nBase+=(bss.nWidth>>1)*nDataHeight;
    bss.nIncY=-bss.nIncY;
  }

  // ------- Sprite is now a simple top to bottom one -------------

  // Clip horizontally
  if (bss.nLeft<0)
  {
    // Adjust to clip to left edge
    nStartBmapX=-bss.nLeft*bss.nIncX; // nBmapX starts further along
    nScrWidth+=bss.nLeft;             // Width is now smaller
    nStartPix=0; bss.nLeft=0;         // Pix now starts on the left edge
    
  }
  else
  {
    // Adjust to start in the middle of the screen
    nStartBmapX=0;                    // nBmapX starts at zero
    nStartPix=bss.nLeft*nBurnBpp; // Pix starts in the middle of the screen
  }

  // Now clip sprite width to the right side
  if (nScrWidth>320-bss.nLeft) nScrWidth=320-bss.nLeft;
  // Find the byte count of the width
  nPixLen=nScrWidth*nBurnBpp;

  // Clip vertically
  if (bss.nTop<0)
  {
    // Adjust to clip to top edge
    nStartBmapY=-bss.nTop*bss.nIncY; // nBmapY starts further along
    bss.nHeight+=bss.nTop;           // Height is now smaller
    bss.nTop=0;                      // Pix now starts on the top edge
  }
  else
  {
    nStartBmapY=0;
  }

  // Now clip sprite to the bottom
  if (bss.nHeight>224-bss.nTop) bss.nHeight=224-bss.nTop;

// Include function for each color depth
if (nBurnBpp==2)
#define BSS_DEPTH (2)
#include "sys_spr.h"
#undef BSS_DEPTH

else if (nBurnBpp==3)
#define BSS_DEPTH (3)
#include "sys_spr.h"
#undef BSS_DEPTH

else if (nBurnBpp==4)
#define BSS_DEPTH (4)
#include "sys_spr.h"
#undef BSS_DEPTH

else
#define BSS_DEPTH (1)
#include "sys_spr.h"
#undef BSS_DEPTH
  return 0;
}
