#include "burnint.h"

// System 16 - Tiles

unsigned char *BsysTileData=NULL; // Pointer to tile bitmap data
int nBsysTileDataLen=0; // Length of data    (must be power of 2)

int nBsysTilePalBase=0; // Palette Base

// Draw one tile 'nTile' at location pDest on the bitmap
static int OneTile(unsigned char *Dest,int nTile,int nPal)
{
  unsigned int *pBmap;   // pointer to tile bitmap
  unsigned int nLine;    // pixels for tile line
  unsigned char *pLine;  // pointer to dest line
  unsigned int *TilePal; // pointer to tile palette
  
  TilePal=BsysPal+((nPal<<3)&(nBsysPalLen-8));

  int x=0,y=0;
  pBmap=(unsigned int *)( BsysTileData+((nTile<<5)&(nBsysTileDataLen-0x20)) );
  for (pLine=Dest,y=0; y<8; pLine+=nBurnPitch,y++)
  {
    unsigned char *pPix;
    nLine=*pBmap++;

    for (pPix=pLine,x=0; x<8; pPix+=nBurnBpp,x++)
    {
      if (nLine&15) PutPix(pPix,TilePal[nLine&7]); nLine>>=4;
    }
  }
  return 0;
}

int BsysTilePage(int nPage,int nTilePage,unsigned char *RamTx)
{
  int ty; unsigned char *pLine;
  (void)nPage;

  for (pLine=pBurnDraw,ty=0; ty<28; pLine+=(nBurnPitch<<3),ty++)
  {
    int tx; unsigned char *pCell;

    for (pCell=pLine,tx=0; tx<40; pCell+=(nBurnBpp<<3),tx++)
    {
      int nTile,nAttrib,nPal,mx,my,nOff;
      mx=tx-0x28; mx&=0x3f; my=ty&0x3f;
      nOff=(my<<7)|(mx<<1); nOff&=0xffe;
      nTile=RamTx[nOff+0]; nAttrib=RamTx[nOff+1];
      nTile+=nTilePage<<6;

      nPal=((nAttrib>>1)&0x0f);
      if (nAttrib&1) nTile+=32*8;
      nPal+=nBsysTilePalBase;

      if (nTile!=0 && nTile!=0x20) OneTile(pCell,nTile,nPal);
    }
  }
  return 0;
}

